/****************************************************************************
** File name    :  HTError.h
** Description  :  define error code
** Create date  :  2018.09.01
** Auther by    :  Liuyx
** Version info :  V1.0.01
** Copyright (C) 2002-2018 xi'an huatek, Inc Co., Ltd
** Update record:  
** DATE         AUTHER   DESC 
** -------------------------------------------------------------------------               
** 2018.09.01   Liuyx    first build
****************************************************************************/
#ifndef __HT_ERROR_H
#define __HT_ERROR_H

#define  RET_OK                    0 
#define  RET_FAIL                  -1 
#define  RET_IPPORT_INVALID        -2   // IP地址或端口无效
#define  RET_UDP_BIND_PORT         -3   // UDP绑定端口错误
#define  RET_LENGTH_INVALID        -4   // 数据长度无效
#define  RET_VALUE_INVALID         -5   // 域值无效
#define  RET_TYPE_INVALID          -6   // 业务类型无效
#define  RET_CALLOC_FAIL           -7   // 申请内存失败
#define  RET_SUB_ID_INVALID        -8   // 域ID标识无效/不支持的ID标识码
#define  RET_CALL_OCI_FAILED       -9   // OCI调用失败
#define  RET_NOT_FOUND_RECORD      -10  // 无原请求业务流水
#define  RET_ERROR_AUTHID          -11  // 无效接入码
#define  RET_UDP_STATUS_EXP        -12  // UDP链接状态异常
#define  RET_NOT_EXTERN_PACK       -13  // 无扩展报文
#define  RET_NOT_FOUND_ACCESSID    -14  // 没有检索到接入码      
#define  RET_TERM_NOT_ONLINE       -15  // 终端不在线
#define  RET_SUB_COMMAND_INVALID   -16  // 采集数据的子命令无效
#define  RET_MAJOR_CONN_ERR        -17  // TCP主链路状态错误
#define  RET_NOT_FILE_EXIST        -18  // 文件不存在
#define  RET_NOT_DATA              -19  // 采集行驶记录无数据
#define  RET_SET_ERROR_PIC         -20  // 插入拍照下发指令记录失败
#define  RET_SERVER_ID_ERR         -21  // 连接服务器名称无效
#define  RET_JT809_VERSION         -22  // 数据库配置了无效的JT809协议版本号
#define  RET_JT808_VERSION         -23  // 808内部报文协议类型无效
#define  RET_JT809_CRC_ERROR       -24  // CRC16校验错误
#define  RET_LINK_CHECK_ERROR      -25  // 链路校验码错误
#define  RET_RECORD_ORG_ID_NULL    -26  // 记录仪ID或企业ID为空
#endif // end __HT_ERROR_H

