/****************************************************************************
** File name    :  HTImageBusi.h
** Description  :  define memory data struct
** Create date  :  2018.09.01
** Auther by    :  Liuyx
** Version info :  V1.0.01
** Copyright (C) 2002-2018 xi'an huatek, Inc Co., Ltd
** Update record:  
** DATE         AUTHER   DESC 
** -------------------------------------------------------------------------               
** 2018.09.01   Liuyx    first build
****************************************************************************/
#ifndef __HT_IMAGE_BUSI_H
#define __HT_IMAGE_BUSI_H
#pragma pack (push ,1)

//图片识别阈值缓存区
typedef struct
{
    unsigned char site_id[DEF_EQM_CODE_SIZE];    // 站点ID
    unsigned char eqm_code[DEF_EQM_CODE_SIZE];   // 主设备编码/主变/GIS/避雷器
    unsigned char system_code[DEF_EQM_CODE_SIZE];// 系统设备编码
    unsigned char sensor_id[DEF_EQM_CODE_SIZE];  // Sensor Code,map key
    unsigned char desc[DEF_BUFFER_256];          // 对应sensor code的描述
    unsigned char eqm_type;                      // 设备类型 1:主变 2:GIS 3:测温柜 4:避雷器
    //unsigned char wstate;                        // 工作状态 1:发电状态 2：抽水状态 3：空闲状态
    unsigned char phase;                         // 相位 O:全相 1:A相 2:B相 3:C相
    double        value[3];                      // 阈值,index=0:发电状态阈值 =1:抽水状态阈值 =2:空闲状态阈值
}ST_IMG_THRESHOLD;


// 加载图片阈值
void vLoadImageThreshold();
void vPrtImageThreshold(void);

// 根据sensor_id，获取阈值
bool getImageThresholdValuse(const char *sensor_id, ST_IMG_THRESHOLD &pstThresdhold);


#pragma pack (pop)
#endif // end 

