/****************************************************************************
** File name    :  HTImageBusi.cpp
** Description  :  define memory data struct
** Create date  :  2018.09.01
** Auther by    :  Liuyx
** Version info :  V1.0.01
** Copyrigth By:  xi'an huatek, Inc Co., Ltd
** Update record:
** DATE         AUTHER   DESC
** -------------------------------------------------------------------------
** 2018.09.01   Liuyx    first build
****************************************************************************/
#include "HTGlobal.h"
//#include "HTIEC104.h"
//#include "HTMemCacheData.h"

static const char *_FILE_ = "HTImageBusi.cpp";


/***************************************************************************
** function name :  getImageThreshold
** deacription   :  get image define value
** parameter     :  none
** return code   :  NULL
***************************************************************************/
static void getImageThreshold(char *szSql)
{
    int  wstate = 0;
    double value = 0.0f;
    CDBMySQL *pdbHandle = CDBMySQL::Instance();
    if (!pdbHandle) return;

    MYSQL_RES *res = pdbHandle->SelectRecord(szSql);
    if (!res)  return;

    MYSQL_ROW row = NULL;
    while (row = pdbHandle->GetRecord(res))
    {
        ST_IMG_THRESHOLD stThreshold;
        string strKey = "";

        memset(&stThreshold, 0x00, sizeof(ST_IMG_THRESHOLD));
        memset(&stThreshold.value, 0xff, sizeof(double) * 3);

        if (row[0] && strlen(row[0]) > 0) {
            strncpy((char*)stThreshold.sensor_id, (const char*)row[0], sizeof(stThreshold.sensor_id));
            strKey = row[0];
        }

        if (row[1] && strlen(row[1]) > 0) {
            strncpy((char*)stThreshold.site_id, (const char*)row[1], sizeof(stThreshold.site_id));
        }

        if (row[2] && strlen(row[2]) > 0) {
            stThreshold.phase = row[2][0];
        }
        if (row[3] && strlen(row[3]) > 0) {
            strncpy((char*)stThreshold.desc, (const char*)row[3], sizeof(stThreshold.desc));
        }
        if (row[4] && strlen(row[4]) > 0) {
            strncpy((char*)stThreshold.eqm_code, (const char*)row[4], sizeof(stThreshold.eqm_code));
        }

        //工作状态：1 - 发电状态 2：抽水状态 3：空闲状态
        if (row[5] && strlen(row[5]) > 0) {
            wstate = atoi((const char*)row[5]);
        }
        if (row[6] && strlen(row[6]) > 0) {
            value = atof((const char*)row[6]);
        }
        else value = HT_INVALID_VALUE;

        if (row[7] && strlen(row[7]) > 0) {
            stThreshold.eqm_type = (unsigned char)atoi((const char*)row[7]);
        }
        if (row[8] && strlen(row[8]) > 0) {
            strncpy((char*)stThreshold.system_code, (const char*)row[8], sizeof(stThreshold.system_code));
        }
        map<string, ST_IMG_THRESHOLD>::iterator m_pIter;
        mutex_lock(g_map_img_thres_mutex);
        m_pIter = g_map_img_thres.find((char*)stThreshold.sensor_id);
        if (m_pIter != g_map_img_thres.end())
        {
            switch (wstate)
            {
            case 1:
                (m_pIter->second).value[0] = value;
                break;
            case 2:
                (m_pIter->second).value[1] = value;
                break;
            case 3:
                (m_pIter->second).value[2] = value;
                break;
            default:;
            }
        }
        else {
            if (wstate == 1) stThreshold.value[0] = value;
            else if (wstate == 2) stThreshold.value[1] = value;
            else if (wstate == 3) stThreshold.value[2] = value;
            g_map_img_thres.insert(map<string, ST_IMG_THRESHOLD>::value_type(strKey, stThreshold));
        }
        mutex_unlock(g_map_img_thres_mutex);
    }
    pdbHandle->FreeRecord(res);
    return;
}
// 加载图片阈值,包括变压器、GIS、避雷器三大主设备
void vLoadImageThreshold()
{
    char szSql[DEF_BUFFER_1K+512] = { 0 };

    // 加载变压器图片阈值
    snprintf(szSql, sizeof(szSql), "SELECT sensor.sensor_code, sensor.site_id, sensor.position, sensor.position_des, tree.id AS m_eqm_code,"
        "t.work_status, t.threshold, t.type, tree.system_code "
        "FROM photo_threshold t, busi_site_tree tree, busi_transformer_sub_tree sub, busi_transformer_sensor sensor "
        "WHERE t.main_tree_id = tree.id AND sub.equipment_id = tree.id AND t.sensor_code = sensor.sensor_code "
        "AND sensor.equipment_id = sub.id and tree.status = '1'and sub.status = '1'and sensor.status = '1' "
        "AND sub.equipment_type = '051' AND tree.equipment_type = '111' "
        "ORDER BY sensor.sensor_code,t.work_status");
    getImageThreshold(szSql);

    // 加载GIS图片阈值
    snprintf(szSql, sizeof(szSql), "SELECT sensor.sensor_code, sensor.site_id, sensor.position, sensor.position_des, tree.id AS m_eqm_code,"
        "t.work_status, t.threshold, t.type, tree.system_code "
        "FROM photo_threshold t, busi_site_tree tree, busi_gis_sub_tree sub, busi_gis_sensor sensor "
        "WHERE t.main_tree_id = tree.id AND sub.equipment_id = tree.id AND t.sensor_code = sensor.sensor_code "
        "AND sensor.equipment_id = sub.id and tree.status = '1'and sub.status = '1'and sensor.status = '1' "
        "AND sub.equipment_type = '061' AND tree.equipment_type = '211' "
        "ORDER BY sensor.sensor_code,t.work_status");
    getImageThreshold(szSql);

    // 加载避雷器图片阈值
    snprintf(szSql, sizeof(szSql), "SELECT sensor.sensor_code, sensor.site_id, sensor.position, sensor.position_des, tree.id AS m_eqm_code,"
        "t.work_status, t.threshold, t.type, tree.system_code "
        "FROM photo_threshold t, busi_site_tree tree, busi_arrester_sub_tree sub, busi_arrester_sensor sensor "
        "WHERE t.main_tree_id = tree.id AND sub.equipment_id = tree.id AND t.sensor_code = sensor.sensor_code "
        "AND sensor.equipment_id = sub.id and tree.status = '1'and sub.status = '1'and sensor.status = '1' "
        "AND sub.equipment_type = '051' AND tree.equipment_type = '411' "
        "ORDER BY sensor.sensor_code,t.work_status");
    getImageThreshold(szSql);
    // 加载其他类图片阈值
    snprintf(szSql, sizeof(szSql), "SELECT sensor.sensor_code, sensor.site_id, sensor.position, sensor.position_des, tree.id AS m_eqm_code,"
        "t.work_status, t.threshold, t.type, tree.system_code "
        "FROM photo_threshold t, busi_site_tree tree, busi_other_sub_tree sub, busi_other_sensor sensor "
        "WHERE t.main_tree_id = tree.id AND sub.equipment_id = tree.id AND t.sensor_code = sensor.sensor_code "
        "AND sensor.equipment_id = sub.id and tree.status = '1'and sub.status = '1'and sensor.status = '1' "
        "AND sub.equipment_type = '031' AND tree.equipment_type = '511' "
        "ORDER BY sensor.sensor_code,t.work_status");
    getImageThreshold(szSql);

}

void vPrtImageThreshold(void)
{
    map<string, ST_IMG_THRESHOLD>::iterator m_pIter;
    m_pIter = g_map_img_thres.begin();
    vPrtLogMsg(LOG_DEBUG, RET_OK, "---------Print Image Threshold Tables----------");
    vPrtLogMsg(LOG_DEBUG, RET_OK, "site_id\t\t\t\t eqm_code\t\t\t system_code\t T  sensor_id  value(1,2,3)");
    while (m_pIter != g_map_img_thres.end())
    {
        vPrtLogMsg(LOG_DEBUG, RET_OK, "%-s %s %s %d %s [%.2f,%.2f,%.2f]",
            (m_pIter->second).site_id, (m_pIter->second).eqm_code, (m_pIter->second).system_code, 
            (m_pIter->second).eqm_type, (m_pIter->second).sensor_id,
            (m_pIter->second).value[0], (m_pIter->second).value[1], (m_pIter->second).value[2]);
        m_pIter++;
    }
    vPrtLogMsg(LOG_DEBUG, RET_OK, "---------- Image_Threshold_size:%d-----------", g_map_img_thres.size());
    return;
}


// 根据sensor_id，获取阈值
bool getImageThresholdValuse(const char *sensor_id, ST_IMG_THRESHOLD &pstThresdhold)
{
    map<string, ST_IMG_THRESHOLD>::iterator m_pIter;
    double val = 0.0f;
    mutex_lock(g_map_img_thres_mutex);
    m_pIter = g_map_img_thres.find((char*)sensor_id);
    if (m_pIter != g_map_img_thres.end())
    {
        memcpy(&pstThresdhold, &(m_pIter->second), sizeof(ST_IMG_THRESHOLD));
        mutex_unlock(g_map_img_thres_mutex);
        return true;
    }
    mutex_unlock(g_map_img_thres_mutex);
    return false;
}




