/****************************************************************************
** File name    :  HTInitUtils.cpp
** Description  :  Defines service initialization API
** Create date  :  2018.09.01
** Auther by    :  Liuyx
** Version info :  V1.0.01
** Copyright (C) 2002-2018 xi'an huatek, Inc Co., Ltd
** Update record:  
** DATE         AUTHER   DESC 
** -------------------------------------------------------------------------               
** 2018.09.01   Liuyx    first build
****************************************************************************/
#include "HTGlobal.h"
#include "HTInitUtils.h"

static const char *_FILE_ = "HTInitUtils.cpp" ;

// make and get a globle seq number
int get_seqno(void)
{
    int iseq = 0;
    mutex_lock(g_seq_mutex);
    iseq = ++g_seqno ;
    if(g_seqno >= 255 ) 
	g_seqno = 0;
    mutex_unlock(g_seq_mutex);
    return iseq;
}

int loadServiceEvent()
{
    // 初始化日志共享资源锁
    vInitLogMutex();                                 // 初始化log文件锁与句柄
    mutex_create(g_seq_mutex); 
    mutex_create(g_IecCtrl_mutex);
    mutex_create(g_map_byq_mutex);
    //mutex_create(g_map_gis_mutex);
    //mutex_create(g_map_blq_mutex);
    //mutex_create(g_map_gis_104_mutex);
    mutex_create(g_map_iec_mutex);
	mutex_create(g_map_iec_mutex_new);
    mutex_create(g_map_relation_mutex);
    mutex_create(g_map_sadr_mutex);
    mutex_create(g_map_img_thres_mutex);
    mutex_create(g_map_work_mutex);
    mutex_create(g_map_dev_time_stat_mutex);
    mutex_create(g_map_gis_state_mutex);
    memset(&g_IecCtrl, 0x00, sizeof(ST_IEC104_CTRL));
    g_Running = 1 ;                                  // 服务启动标志
    g_TConfig.getIniConfig();
    IEC104EnvLoad();
    if(!CDBMySQL::Instance()->dbConnectPool()) {
        vFreeLogMutex();                            // 释放log文件锁与句柄
        mutex_close(g_seq_mutex);
        mutex_close(g_IecCtrl_mutex);
        mutex_close(g_map_byq_mutex);
        //mutex_close(g_map_gis_mutex);
        //mutex_close(g_map_blq_mutex);
        //mutex_close(g_map_gis_104_mutex);
        mutex_close(g_map_iec_mutex);
		mutex_close(g_map_iec_mutex_new);
        mutex_close(g_map_relation_mutex);
        mutex_close(g_map_sadr_mutex);
        mutex_close(g_map_img_thres_mutex);
        mutex_close(g_map_work_mutex);
        mutex_close(g_map_dev_time_stat_mutex);
        mutex_close(g_map_gis_state_mutex);
        IEC104EnvFree(); 
        g_Running = 0 ;
        return RET_FAIL;
    }
    return RET_OK;
}

// 重新从数据库加载配置
void reloadServiceEvent(int platform_id)
{
    //TDatabase* g_TDatabase = NULL;
    //g_TDatabase = TDatabase::Instance();
}

int unLoadServiceEvent()
{
    CDBMySQL::Instance()->dbFreeConnectPool();
    g_Running = 0 ;
    HTFreeThreadHandle();
    // 释放日志共享资源锁

    mutex_close(g_seq_mutex);
    mutex_close(g_IecCtrl_mutex);
    mutex_close(g_map_byq_mutex);
   // mutex_close(g_map_gis_mutex);
   // mutex_close(g_map_blq_mutex);
    //mutex_close(g_map_gis_104_mutex);
    mutex_close(g_map_iec_mutex);
	mutex_close(g_map_iec_mutex_new);
    mutex_close(g_map_relation_mutex);
    mutex_close(g_map_sadr_mutex);
    mutex_close(g_map_img_thres_mutex);
    mutex_close(g_map_work_mutex);
    mutex_close(g_map_dev_time_stat_mutex);
    mutex_close(g_map_gis_state_mutex);
    IEC104EnvFree();
    return RET_OK;
}



