/******************************************************************************
** Filename   :   HTService.cpp
** Description:   main file
** Create Date:   2018-09-08
** Auth By    :   Liuyx
** Update Date:   2018-09-08
** Copyrigth By:  xi'an huatek, Inc Co., Ltd
******************************************************************************/
#include "HTGlobal.h"

static const char *_FILE_ = "HTService.cpp" ;
CDBMySQL* CDBMySQL::p_dbHandle = NULL;

static char is_down = 0 ;

// 终止所有业务工作线程
static void cancel_thread_work(void)
{
#ifndef _WIN32
    int i = 0 ;
    if(thread_handle_client) {
        pthread_cancel(thread_handle_client);
        pthread_join(thread_handle_client, NULL);
        pthread_kill(thread_handle_client, SIGURG);
    }
    vPrtLogMsg(LOG_DEBUG, RET_OK,"thread_handle_client shutdown.") ;

    if(thread_handle_linkmgr) {
        pthread_cancel(thread_handle_linkmgr);
        pthread_join(thread_handle_linkmgr, NULL);
        pthread_kill(thread_handle_linkmgr, SIGURG);
    } 
    vPrtLogMsg(LOG_DEBUG, RET_OK,"thread_handle_linkmgr shutdown.") ;

    if(thread_handle_recv) {
        pthread_cancel(thread_handle_recv);
        pthread_join(thread_handle_recv, NULL);
        pthread_kill(thread_handle_recv, SIGURG);
    } 
    vPrtLogMsg(LOG_DEBUG, RET_OK,"thread_handle_recv shutdown.") ;
    
    if(thread_handle_active) {
        pthread_cancel(thread_handle_active);
        pthread_join(thread_handle_active, NULL);
        pthread_kill(thread_handle_active, SIGURG);
    } 
    vPrtLogMsg(LOG_DEBUG, RET_OK,"thread_handle_active shutdown.") ;


    //for(i=0; i < (int)g_TConfig.getParseThreadNumber(); i++) {
        if(thread_handle_parse) {
            pthread_cancel(thread_handle_parse);
            pthread_join(thread_handle_parse, NULL);
            pthread_kill(thread_handle_parse, SIGURG);
        }
    //}
    vPrtLogMsg(LOG_DEBUG, RET_OK,"thread_handle_parse group shutdown.") ;

    //
    //for(i=0; i < (int)g_TConfig.getOprationThreadNumber(); i++) {
    //    if(thread_handle_opration[i]) {
    //        pthread_cancel(thread_handle_opration[i]);
    //        pthread_join(thread_handle_opration[i], NULL);
    //        pthread_kill(thread_handle_opration[i], SIGURG);
    //    }
    //}
    //vPrtLogMsg(LOG_DEBUG, RET_OK,"thread_handle_opration group shutdown.") ;

    //for(i=0; i < (int)g_TConfig.getResponeThreadNumber(); i++) {
    if(thread_handle_active) {
        pthread_cancel(thread_handle_active);
        pthread_join(thread_handle_active, NULL);
        pthread_kill(thread_handle_active, SIGURG);
        }
    //}
    vPrtLogMsg(LOG_DEBUG, RET_OK,"thread_handle_respone group shutdown.") ;
#endif
}
static void sig_exit(int signo)
{
    vPrtLogMsg(LOG_DEBUG, errno,"recv signal, service shutdown.sig:%d", signo ) ;
    
    cancel_thread_work(); 
    vPrtLogMsg(LOG_DEBUG, errno,"unloading service is done...1");
    g_Running = 0 ;  // 先停止所有的业务线程

    _SLEEP(1000*2);

    vPrtLogMsg(LOG_DEBUG, errno,"unloading service is done...2");
    unLoadServiceEvent();// 卸载运行配置
    is_down = 0 ;
    vPrtLogMsg(LOG_DEBUG, errno,"unloading service is done.");
}

void sig_chld(int signo)
{
#ifndef _WIN32
    pid_t        pid;
    int         stat;
    while ( (pid = waitpid(-1, &stat, WNOHANG)) > 0)
        vPrtLogMsg(LOG_DEBUG, RET_OK, "child %d terminated\n", pid);
#endif
    return;
}

// 创建守护进程环境
static int HTStartBackgroundProcess()
{
#ifdef __NETBEANS__
	// If in Netbeans IDE
	return 0;
#endif
#ifndef _WIN32
	pid_t pid;
	
	// 1.转变为后台进程
	if ((pid = fork() ) != 0 )
		exit( 0);
 
	// 2.离开原先的进程组
	setsid();
 
	// 3.禁止再次打开控制终端
	if ((pid = fork() ) != 0 )
		exit( 0);
 
	// 4.关闭打开的文件描述符，避免浪费系统资源
	/*
	rlimit rlim;
	if(getrlimit(RLIMIT_NOFILE,&rlim) == 0)
	{
		for(int fd=3; fd<=(int)rlim.rlim_cur; fd++)
		{
			close(fd);
		}
	}
	*/
 
	// 5.改变当前的工作目录，避免卸载不了文件系统
	//if (chdir("/") == -1) exit(1);
 
	// 6.重设文件掩码，防止某些属性被父进程屏蔽
	umask(0);
	setpgrp();
 
	// 7.重定向标准输入，输出，错误流，因为守护进程没有控制终端
	/*
	if ((fd = open("/dev/null", O_RDWR)) == -1) 
		exit(1); 
	dup2(fd, STDIN_FILENO);
	dup2(fd, STDOUT_FILENO);
	dup2(fd, STDERR_FILENO);
	close(fd);
	*/
    signal(SIGINT, sig_exit);  // Program terminated with signal 11, Segmentation fault.
    signal(SIGTERM, sig_exit);
	// 8.屏蔽信号
	signal( SIGHUP,  SIG_IGN);
	signal( SIGQUIT, SIG_IGN);
	signal( SIGPIPE, SIG_IGN);
	signal( SIGTTOU, SIG_IGN);
	signal( SIGTTIN, SIG_IGN);
	signal( SIGCHLD, SIG_IGN);
 
	struct sigaction sig;
 
	sig.sa_handler = SIG_IGN;
	sig.sa_flags = 0;
	sigemptyset( &sig.sa_mask);
	sigaction( SIGHUP,&sig,NULL);
#endif	
	return 0;
}


void getcptime(unsigned char *data, int len) 
{
    SYSTEMTIME st ;
        
    st.wMilliseconds = (data[0]+ 256 * data[1])%1000; 
        
    st.wSecond = (data[0] + 256 * data[1])/1000; 

    st.wMinute = data[2] & 0x3f;

    st.wHour = data[3]&0x1f;

    st.wDay = data[4]&0x1f;

    st.wMonth = data[5]&0x0f;

    st.wYear = data[6] & 0x7f;
}

static void Usage(char *prgname)
{
    printf("==>> Usage: \n");
    printf("      %s [start | stop | version] [img_file shigh ehigh swidth ewidth[tabtype 180 | 360]]\n", prgname);
    printf("Parameters:\n");
    printf("      --> img_file                           ... Pictures file path and name\n");
    printf("      --> shigh                              ... Pictures's start high pointer\n");
    printf("      --> ehigh                              ... Pictures's end high pointer\n");
    printf("      --> swidth                             ... Pictures's start width pointer\n");
    printf("      --> ewidth                             ... Pictures's end width pointer\n");
    // add by ramon 2019-06-27, add TYPE=xxxx
    printf("      --> tabtype:[TYPE]                     ... Pictures's end width pointer,TYPE=3EX5050 | JSY-10 | YZF250TH\n");
    
    printf("Examples:\n");
    printf("      --> %s  start                          ... Startup Service\n", prgname);
    printf("      --> %s  stop                           ... Shutdown Service\n", prgname);
    printf("      --> %s  ./img.jpg 10 200 50 210        ... Clipping pictures to high(10,200) width(50,210)\n", prgname);
    // add by ramon 2019-06-27, add TYPE=xxxx
    printf("      --> %s  ./img.jpg TYPE 180|360         ... Get pictuer point value, TYPE=3EX5050|JSY-10|YZF250TH\n", prgname);
    printf("      --> %s  ./img.jpg 10 200 50 210 JSY-10 360   ... Clipping pictures and get point number\n", prgname);
    printf("      --> %s  ./img.jpg 10 200 50 210 3EX5050 180  ... Clipping pictures and get point number\n", prgname);
    printf("      --> %s  ./img.jpg 10 200 50 210 YZF250TH 360 ... Clipping pictures and get point number\n", prgname); // add by ramon 2019-06-27
    printf("Version:\n");
    //printf("      %s version %s Copyright (c) 2020 the Huatek developers group.\n", prgname, HT_VERSION_BUILD_ID);
    printf("      %s version %s Copyright (c) 2020 the Xydl developers group.\n", prgname, HT_VERSION_BUILD_ID);
}

static void task_kill()
{
    char szCmd[128] = { 0 };
    int pid = iGetPid();
#ifdef _WIN32
    sprintf(szCmd, "taskkill /PID %d /F", pid);
#else
    sprintf(szCmd, "kill -9 %d >/dev/null 2>&1", pid);
#endif
    system(szCmd);
}
#if 1
int main(int argc, char* argv[])
{
    //char szTime[] = "20191122140322";
    //char szOut[32] = { 0 };
    //double dOilTempOuter = -9999.0f, dInitValue = -9999.0f;
    //vFormatTimes(szTime, szOut);
    //printf("szTime=%s   out=%s\n", szTime, szOut);
    //for (int i = 0; i < 100; i++)
    //    printf("%s\n", double2str(dOilTempOuter, dInitValue, szOut));

    //getchar();

    if (argc != 2 && argc != 4 && argc != 6 && argc != 8) {
        Usage(argv[0]);
        return 0;
    }
    if (argc == 4)  //获取图片指针读数
    {
        vInitLogMutex();                                 // 初始化log文件锁与句柄
        g_TConfig.getIniConfig();
        ST_OPENCV_CONF  stConf;
        strcpy((char*)stConf.img_path, argv[1]);
        stConf.is_replace = false;
        strcpy((char*)stConf.table_type, argv[2]);
        stConf.base_angle = atoi(argv[3]);
        stConf.dInitVal = 1;

        printf("-->> Table type:[%s]   Base_angle:[%d°]\n", argv[2], stConf.base_angle);
        if (stringncasecmp("JSY-10", argv[2], strlen("JSY-10")) == 0)
            printf("-->> ReadPoint: [%s] read num: %.2f\n", argv[1], dReadPointValue_JSY10(&stConf, argv[1]));
        else if (stringncasecmp("3EX5050", argv[2], strlen("3EX5050")) == 0) 
            printf("-->> ReadPoint: [%s] read num: %.2f\n", argv[1], dReadPointValue_3EX5050(&stConf, argv[1]));
        // add by ramon 2019-06-27
        else if (stringncasecmp("YZF250TH", argv[2], strlen("YZF250TH")) == 0)
            printf("-->> ReadPoint: [%s] read num: %.2f\n", argv[1], dReadPointValue_JSY10(&stConf, argv[1]));
        // add by ramon 2019-06-27
        else printf("ERROR-->> Unkonw table type:%s,  TYPE: JSY-10|3EX5050|YZF250TH", argv[2]);
        //getchar();
        return 0;
    }
    if (argc == 6)  // 截图工具方式
    {
        ST_OPENCV_CONF  stConf;
        strcpy((char*)stConf.img_path, argv[1]);
        stConf.s_height = atoi(argv[2]);
        stConf.e_height = atoi(argv[3]);
        stConf.s_width = atoi(argv[4]);
        stConf.e_width = atoi(argv[5]);
        stConf.is_replace = false;
        vCutImageSave(&stConf, argv[1]);
        printf("-->> Clipping pictures:[%s] to :[%s] ... complete.\n", stConf.img_path, argv[1]);
        return 0;
    }
    if (argc == 8)  //获取图片指针读数
    {
        vInitLogMutex();                                 // 初始化log文件锁与句柄
        g_TConfig.getIniConfig();
        ST_OPENCV_CONF  stConf;
        strcpy((char*)stConf.img_path, argv[1]);
        stConf.s_height = atoi(argv[2]);
        stConf.e_height = atoi(argv[3]);
        stConf.s_width = atoi(argv[4]);
        stConf.e_width = atoi(argv[5]);
        stConf.is_replace = false;
        stConf.dInitVal = 5.8f;
           
        strcpy((char*)stConf.table_type, argv[6]);
        stConf.base_angle = atoi(argv[7]);
        vCutImageSave(&stConf,argv[1]);
        printf("-->> Clipping pictures:[%s] to :[%s] ... complete.\n", stConf.img_path, argv[1]);
        printf("-->> Table type:[%s]   Base_angle:[%d°]\n", (char*)stConf.table_type, stConf.base_angle);
        if (stringncasecmp("JSY-10", argv[6], strlen("JSY-10")) == 0)
            printf("-->> ReadPoint: [%s] read num: %.2f\n", argv[1], dReadPointValue_JSY10(&stConf, argv[1]));
        else if (stringncasecmp("3EX5050", argv[6],strlen("3EX5050")) == 0)
            printf("-->> ReadPoint: [%s] read num: %.2f\n", argv[1], dReadPointValue_3EX5050(&stConf, argv[1]));
        // add by ramon 2019-06-27
        else if (stringncasecmp("YZF250TH", argv[6], strlen("YZF250TH")) == 0)
            printf("-->> ReadPoint: [%s] read num: %.2f\n", argv[1], dReadPointValue_JSY10(&stConf, argv[1]));
        else printf("ERROR-->> Unkonw table type:%s,  TYPE: JSY-10|3EX5050|YZF250TH", argv[6]);
        return 0;
    }

    if (argc == 2) {
        if (!stringcasecmp("start", argv[1])) {
            int i = 0;
            is_down = 1;
            
			if (RET_OK != loadServiceEvent())
			{
				return 0;    // 加载运行配置
			}
            HTStartBackgroundProcess();
            HTInitThreadHandle();
            vSetPid();  // 记录PID

            ht_pthread_create_background(&thread_handle_cache,thread_cache_proc,NULL);        // 内存数据同步线程
#ifdef _HT_IEC104_APP            
            ht_pthread_create_background(&thread_handle_warning, thread_warn_proc, NULL);     // 告警处理线程
            ht_pthread_create_background(&thread_handle_origin, thread_origin_proc, NULL);    // 原始数据入库线程
			ht_pthread_create_background(&thread_handle_origin_new, thread_origin_proc_new, NULL);    // 原始数据入库线程
			ht_pthread_create_background(&thread_handle_busi_data, thread_busi_data_proc, NULL);    // 业务数据入库线程
            ht_pthread_create_background(&thread_handle_pingce, thread_pingce_proc, NULL);    // 评测数据入库线程
            ht_pthread_create_background(&thread_handle_gishold, thread_gis_hold_proc, NULL); // 评测数据入库线程

			ht_pthread_create_background(&thread_handle_linkmgr, thread_listen_proc, NULL);   // 链路管理线程
                        
                        ht_pthread_create_background(&thread_handle_recv, thread_recv_proc, NULL);
        
            // ht_pthread_create_background(&thread_handle_linkmgr, thread_client_proc, NULL);   // 链路管理线程
            ht_pthread_create_background(&thread_handle_parse, thread_parser_proc, NULL);     // 104报文解析线程
            ht_pthread_create_background(&thread_handle_timer, thread_Timer_proc, NULL);      // 104链路超时管理线程
            ht_pthread_create_background(&thread_handle_active, thread_active_proc, NULL);    // 104报文应答线程
#endif       
#ifdef _HT_OPENCV_APP
            ht_pthread_create_background(&thread_handle_opecvimg, thread_opencv_proc, NULL);  // 图片解析线程
#endif
            printf("Service start ...... OK\n");
            while (1) {
                if (!is_down) break;
                _SLEEP(2000);
            }
            vPrtLogMsg(LOG_DEBUG, 0, "free manager database connection pool:%s/%s@%s successed!",
                g_TConfig.getdbUserName(), g_TConfig.getdbUserPass(), g_TConfig.getdbName());
            vPrtLogMsg(LOG_DEBUG, 0, "HTService shutdown completed immediately!");
            vFreeLogMutex(); // 关闭log文件锁与句柄
            return 0;
        }
        if (!stringcasecmp("stop", argv[1])) {
            task_kill();
            printf("Service stop ...... OK\n");
            return 0;
        }
        if (!stringcasecmp("version", argv[1])) {
            printf("--> %s version %s Copyright (c) 2020 the Xydl developers group.\n", argv[0], HT_VERSION_BUILD_ID);
            return 0;
        }
    }
    Usage(argv[0]);
    return 0;
}

#else
bool bSetPointTableValue(unsigned char *v, int len, unsigned int adr, char stype)
{
    unsigned char cval = 0;
    float fval = 0;
    switch (stype)
    {
    case  1:  // 遥信量
        if (v)  cval = ((unsigned char)v[0] & 0xff);
        printf("cval=%d\n", cval);
        break;
    case 2:   // 遥测量
        if (v) memcpy(&fval, &v, len);
            
        printf("fval=%.3f\n", fval);
        break;
    default:
        break;
    }
    
    return true;
}



//计算得到指针指向的角度 theta，直接测量可以得到指针刻度起点所对应的角度 minangle，
//以及终止角度maxangle，以及最大刻度量 10.
//则可以得到实际的示数：
//
//value = （theta - minangle) * 10 / (maxangle - minangle)
//
//利用这个公式对上图的示数进行计算，
//
//minangle = 60 maxangle = 320 最大刻度量 10，theta = 220
//
//value = （220 - 60） * 10 / （320 - 60） = 6.15384615....
//
//接近真实数值，当然为了获得尽可能准确的数值，我们需要精确的 minangle maxangle 以及theta
///////////////////////////////
//指针所在的线段是我们通过霍夫检测得到的，
//所以我们可以得到线段的两个端点 a(x1, y1) b(x2, y2)
//计算线段的 tan(theta), 然后计算反三角函数得到 theta
//前面我们得到圆的一些基本参数：圆心坐标 c(x, y), 半径 r
//假设 a 是离圆心的近点，b 是远点
//
//x_angle = x2 - x
//y_angle = y - y2
//
//一定要注意这里是 y - y2，不是 y2 - y，
//这是因为对图像所在的笛卡尔直角坐标系，（0，0）点在图像的左上角，
//所以越往下 y 越大。
//
//则有 tan(theta) = y_angle / x_angle  theta = arctan(tan(theat))
/////////////////////////////
//（1）(x_angle > 0 and y_angle >0) or(x_angle > 0 and y_angle < 0)
//
//    final_theta = 270 - theta
//
//    但是这包含了两种小情况，前半部分说明指针的终点在右半部分的上半部分，
//    theta > 0, final_theta < 270；后半部分说明指针的终点在右半部分的
//    下半部分，theta < 0, final_theta > 270.
//(2) (x_angle < 0 and y_angle >0) or(x_angle < 0 and y_angle < 0)
//
//    final_theta = 90 - theta
//
//    依然是两种情况，前半部分说明指针指向的是左半部分的上半部分，
//    theta < 0, final_theta > 90; 后半部分说明指针指向了左半部分的
//    下半部分，theta > 0, final_theta < 90
void genWainningTables()
{

}
/** @函数 main */
int main(int argc, char** argv)
{
   // vInitPress_OCR17NI12MO2_16();

    if (argc == 6)  // 截图工具方式
    {
        ST_OPENCV_CONF  stConf;
        strcpy((char*)stConf.img_path, argv[1]);
        stConf.s_height = atoi(argv[2]);
        stConf.e_height = atoi(argv[3]);
        stConf.s_width = atoi(argv[4]);
        stConf.e_width = atoi(argv[5]);
        stConf.is_replace = false;
        vCutImageSave(&stConf, argv[1]);
        printf("-->> Clipping pictures:[%s] to :[%s] ... complete.\n", stConf.img_path, argv[1]);
        //return 0;
    }
    HTImgAnalys(argv[1]);

    return 0;
}
#endif
