#############################################################################
# HTService project makefile
#
# 说明:
#   CFLAGS: 宏BIG_ENDIAN在Sun Solaris下必须设定,而在Linux系统下不能设定此宏.
#   LIBS  : 在Sun Solaris下必须指定库"-lsocket",在Linux下必须去除该库.
#
#############################################################################

CC = g++

MYSQL_LIB_PATH = /usr/lib64/mysql
MYSQL_LIB_FILE = mysqlclient

#CFLAGS = -c -Werror -g -D_REENTRANT -Wformat -Wsign-compare -O3 -ansi
CFLAGS = -c -Werror -g -D_DEBUG -D_REENTRANT -Wformat -Wsign-compare -O3 -ansi
LIBS =  -L$(MYSQL_LIB_PATH) -L/usr/local/lib64 -l$(MYSQL_LIB_FILE) -lopencv_core -lopencv_imgproc  -lnsl -lpthread -lm -lc -lstdc++

INCPATH = -I../include -I$(MYSQL_PATH)/include

# global file
OBJS_PATH = ../obj
OBJS = $(OBJS_PATH)/HTService.o $(OBJS_PATH)/HTGlobal.o \
	$(OBJS_PATH)/HTPublic.o $(OBJS_PATH)/HTThread.o \
	$(OBJS_PATH)/HTInitUtils.o $(OBJS_PATH)/HTLogger.o \
	$(OBJS_PATH)/HTDatabase.o $(OBJS_PATH)/HTTcpSocket.o \
	$(OBJS_PATH)/HTConfig.o $(OBJS_PATH)/HTIEC104.o \
	$(OBJS_PATH)/NsIec104Server.o $(OBJS_PATH)/HTCP56Time2a.o \
	$(OBJS_PATH)/HTOpencvImg.o $(OBJS_PATH)/HTTestOpencv.o

TARGET = ../bin/HTService

# for link
$(TARGET):$(OBJS)
	$(CC) -Wall -O3 -o $(TARGET) $(OBJS) $(LIBS)

$(OBJS_PATH)/%.o : ./%.cpp
	$(CC) $(CFLAGS) $(INCPATH) $< -o $@
$(OBJS_PATH)/%.o : ./compress/%.c
	cc $(CFLAGS) $(INCPATH) $< -o $@

################################################################
# clean flag str....

clean:
	rm -rf $(OBJS_PATH)/*.o ../bin/core.* ../log/*.log $(TARGET)
log :
	rm -rf ../log/*.log ../bin/core.*
obj:
	rm -rf $(OBJS_PATH)/*.o
